//
//  SecondController.swift
//  closureDemo1
//
//  Created by apple on 2016/12/29.
//  Copyright © 2016年 wusu. All rights reserved.
//

import UIKit

//定义闭包   传一个字符串， 没有返回值类型
typealias InputClosureType = (String) ->Void

//代理 
protocol SecondDelegate:NSObjectProtocol{
    
    func fetchBackString(str:String)

}

class SecondController: UIViewController {

    
    var mySecond = UITextField()
    var back = UIButton()
    
    var backDele = UIButton()
    
    
    // 声明一个back
    var backClosure:InputClosureType?
    // 代理  类oc weak id<SecondDelegate> delegate
    weak var delegate:SecondDelegate?
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.view.backgroundColor = UIColor.orange
        
        mySecond.borderStyle = .bezel
        mySecond.placeholder = "想写啥"
        mySecond.frame = CGRect(x:40, y:40, width:220, height:34)
        
        
        self.view .addSubview(mySecond)
        
        
        back.setTitle("闭包返回", for: .normal)
        
        back.addTarget(self, action:#selector(onBack), for: .touchUpInside)
        back.frame = CGRect(x:30, y:70, width:230, height: 34)
        
        self.view.addSubview(back)
        //---------------------
        backDele.setTitle("代理返回", for: .normal)
        
        backDele.addTarget(self, action:#selector(onBackDele), for: .touchUpInside)
        backDele.frame = CGRect(x:30, y:120, width:230, height: 34)
        
        self.view.addSubview(backDele)
        
        
        

        // Do any additional setup after loading the view.
    }

    
    func onBack() -> Void {
        print("返回")
        self.view.endEditing(true)
        
        //闭包回调
        self.backClosure?(mySecond.text!)
        
        
        self.dismiss(animated: true, completion: nil)
    }
    
    func onBackDele() -> Void {
        print("返回")
        self.view.endEditing(true)
        // 代理回调
        delegate?.fetchBackString(str: mySecond.text!)
        self.dismiss(animated: true, completion: nil)
    }
    
   
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
